/* Copyright 2009 Steven Reynolds
 *  Demonstrate simple traits */

class Celeb(n:String) {
    private val name = n
    override def toString = name
}

trait TVStar {
    var show = ""
    override def toString = super.toString + ". On " + show
}

trait Author {
    var books:Set[String] = Set()
    override def toString = super.toString + ". books: " + books
}

trait Singer {
    var hits:Set[String] = Set()
    override def toString = super.toString + ". hits: " + hits
}

object CelebEx {
    def main(args: Array[String]) :Unit = {
        
        val nancy_grace = new Celeb("Nancy Grace") with Author with TVStar
        nancy_grace.show = "Nancy Grace Show"
        nancy_grace.books = Set("The Eleventh Victim","Objection!","Secrets Can Be Murder")
        println("nancy_grace is: " + nancy_grace)

        val paula_abdul = new Celeb("Paula Abdul") with Singer
        paula_abdul.hits = Set("Straight Up", "Forever Your Girl", "Cold Hearted","Opposites Attract")
        println("paula_abdul is: " + paula_abdul)
    }
}
