/* Copyright 2009 Steven Reynolds
 *  Demonstrate matching */

sealed abstract class Dog(name:String) { override def toString = name }
case class Mixed(name:String) extends Dog(name)
case class CavalierKingCharlesSpaniel(name:String) extends Dog(name)
case class AmericanEskimo(name:String) extends Dog(name)
case class Beagel(name:String) extends Dog(name)

object kennel {
    def feed(dog:Dog) = {
        dog match {
            case Mixed(n) => print("fed " + n + " chicken\n")
            case AmericanEskimo("Samantha") => println("fed Samantha peas and carrots, and then she stole a loaf of bread")
            case CavalierKingCharlesSpaniel(n) => println(n + " rejected chicken, peas and carrots")
            case _ => println("fed " + dog + " some dog food\n")
        }
    } 
}

object DogsEx {
    def main(args: Array[String]) :Unit = {
        val bc = Mixed("BC")
        val sam = AmericanEskimo("Samantha")
        val noel = CavalierKingCharlesSpaniel("Noel")
        val scooby = Beagel("Scooby")
        kennel.feed(bc)
        kennel.feed(sam)
        kennel.feed(noel)
        kennel.feed(scooby)
    }
}
