/* Copyright 2009 Steven Reynolds
 *  Demonstrate functional programming */

object FunEx {
    def main(args: Array[String]) :Unit = {
        // fruit is immutable (both the List and the reference fruit)
        val fruit = "Apple" :: "Orange" :: "Blueberry" :: "Pear" :: Nil;
        println("fruit is " + fruit)
        //fruit += "Pinapple"  <-- not allowed

        //                   a function as an argument
        println("fruit filtered Apple is " + fruit.filter(x => x.equals("Apple")))
        //                   a function as an argument
        println("fruit removed rr is " + fruit.remove(x => x.contains("rr")))

        // set variable to function
        var myfunc = (x: Int) => x + 2
        println("myfunc(5) is " + myfunc(5))

        val my2ndfunc = (x:Int) => {
            myfunc(x) + 3  // myfunc is un-bound in this scope, so it is evaluated in the
                           // enclosing scope
        }
        println("my2ndfunc(5) is " + my2ndfunc(5))
        myfunc = (x:Int) => 7*x // changing myfunc will change my2ndfunc too
        println("my2ndfunc(5) is now " + my2ndfunc(5))

        // take a function, and return a function
        def add11(f:Int => Int) = {
            f(_:Int)+11
        }
        val plus13 = add11(x => x + 2)
        println("plus13(5) is " + plus13(5))
    }

}
