/* Copyright 2009 Steven Reynolds
 *  Compare traits to multiple inheritance */

class Person(n:String) {
    private val name = n
    def to_string = name
}

class Student(n:String, m:String) extends Person(n) {
    private var major = m
    override def to_string = super.to_string + " " + major
}

trait Worker {
    protected var salery:double = 0
    def getSalery = salery
}

class StudentWorker(n:String, m:String, s:double) extends Student(n,m) with Worker  {
    salery = s
    override def to_string = super.to_string + " " + getSalery
}

object StudentWorkerEx {
    def main(args: Array[String]) :Unit = {
        val joe = new StudentWorker("joe","computer science",10)
        println(joe.to_string)
    }

}
